package cn.com.ctop.kuaishou.modules.channel.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import cn.com.ctop.kuaishou.modules.channel.entity.KuaishouChannelAppInfo;
import cn.com.ctop.kuaishou.modules.channel.service.IKuaishouChannelAppInfoService;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;

import java.util.Date;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 渠道功能创建的应用记录
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2021-09-02
 */
@Slf4j
@Api(tags = "渠道功能创建的应用记录")
@RestController
@RequestMapping("/ctop_kuaishou_channel_app_info/kuaishouChannelAppInfo")
public class KuaishouChannelAppInfoController {
    @Autowired
    private IKuaishouChannelAppInfoService kuaishouChannelAppInfoService;

    /**
     * 分页列表查询
     *
     * @param kuaishouChannelAppInfo
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @ApiOperation(value = "渠道功能创建的应用记录-分页列表查询", notes = "渠道功能创建的应用记录-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<KuaishouChannelAppInfo>> queryPageList(KuaishouChannelAppInfo kuaishouChannelAppInfo,
                                                               @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                               @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                               HttpServletRequest req) {
        Result<IPage<KuaishouChannelAppInfo>> result = new Result<>();
        QueryWrapper<KuaishouChannelAppInfo> queryWrapper = QueryGenerator.initQueryWrapper(kuaishouChannelAppInfo, req.getParameterMap());
        Page<KuaishouChannelAppInfo> page = new Page<KuaishouChannelAppInfo>(pageNo, pageSize);
        IPage<KuaishouChannelAppInfo> pageList = kuaishouChannelAppInfoService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param kuaishouChannelAppInfo
     * @return
     */
    @ApiOperation(value = "渠道功能创建的应用记录-添加", notes = "渠道功能创建的应用记录-添加")
    @PostMapping(value = "/add")
    public Result<KuaishouChannelAppInfo> add(@RequestBody KuaishouChannelAppInfo kuaishouChannelAppInfo) {
        Result<KuaishouChannelAppInfo> result = new Result<>();
        try {
            kuaishouChannelAppInfoService.save(kuaishouChannelAppInfo);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param kuaishouChannelAppInfo
     * @return
     */
    @ApiOperation(value = "渠道功能创建的应用记录-编辑", notes = "渠道功能创建的应用记录-编辑")
    @PutMapping(value = "/edit")
    public Result<KuaishouChannelAppInfo> edit(@RequestBody KuaishouChannelAppInfo kuaishouChannelAppInfo) {
        Result<KuaishouChannelAppInfo> result = new Result<KuaishouChannelAppInfo>();
        KuaishouChannelAppInfo kuaishouChannelAppInfoEntity = kuaishouChannelAppInfoService.getById(kuaishouChannelAppInfo.getId());
        if (kuaishouChannelAppInfoEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = kuaishouChannelAppInfoService.updateById(kuaishouChannelAppInfo);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "渠道功能创建的应用记录-通过id删除", notes = "渠道功能创建的应用记录-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id") String id) {
        try {
            kuaishouChannelAppInfoService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @ApiOperation(value = "渠道功能创建的应用记录-批量删除", notes = "渠道功能创建的应用记录-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<KuaishouChannelAppInfo> deleteBatch(@RequestParam(name = "ids") String ids) {
        Result<KuaishouChannelAppInfo> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.kuaishouChannelAppInfoService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "渠道功能创建的应用记录-通过id查询", notes = "渠道功能创建的应用记录-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<KuaishouChannelAppInfo> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<KuaishouChannelAppInfo> result = new Result<>();
        KuaishouChannelAppInfo kuaishouChannelAppInfo = kuaishouChannelAppInfoService.getById(id);
        if (kuaishouChannelAppInfo == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(kuaishouChannelAppInfo);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<KuaishouChannelAppInfo> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                KuaishouChannelAppInfo kuaishouChannelAppInfo = JSON.parseObject(deString, KuaishouChannelAppInfo.class);
                queryWrapper = QueryGenerator.initQueryWrapper(kuaishouChannelAppInfo, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<KuaishouChannelAppInfo> pageList = kuaishouChannelAppInfoService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "渠道功能创建的应用记录列表");
        mv.addObject(NormalExcelConstants.CLASS, KuaishouChannelAppInfo.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("渠道功能创建的应用记录列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<KuaishouChannelAppInfo> listKuaishouChannelAppInfos = ExcelImportUtil.importExcel(file.getInputStream(), KuaishouChannelAppInfo.class, params);
                kuaishouChannelAppInfoService.saveBatch(listKuaishouChannelAppInfos);
                return Result.ok("文件导入成功！数据行数:" + listKuaishouChannelAppInfos.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
